<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

  include("config/global.inc.php");
  checkPermissions(1, $SESSION_TIMEOUT); // user logged in? - keep session alive...

  /* more security */
  $strUserID = validateNumber($LA['au-userid'], $_FORM['txtUserID'], -1, 1000000, FALSE);
  $strGuest  = validateNumber($LA['au-guest-flag'], $_FORM['txtGuest'], 0, 1, FALSE);

  // non admins go bye-bye
  // users (admins) trying to edit their own profile go bye-bye (this prevents a database from getting no admins)
  /* more security - changed next line */
  if(!$CURRENT_USER['IS_A_DB_ADMIN'] || $CURRENT_USER['ID']==$strUserID)
  {
    redirect("$PAGE_EDIT_USER");
    exit;
  }

  // Either:
  // Creating New User (txtUserID==-1 AND a Username exists
  // -OR-
  // Editing a User (btnSubmit exists) AND USER ID exists

  if ($_FORM['deleteSubmit'])
  { 
    /* more security - changed next line */
    //if($_FORM['txtUserID'] && $_FORM['txtUserID']!=$CURRENT_USER['ID'])
    if($_FORM['txtUserID'] && $strUserID!=$CURRENT_USER['ID'])
    {
      //$strUserID       = validateText("User ID", $_FORM['txtUserID'], 1, 20, TRUE, FALSE);
      $strUserID = validateNumber($LA['au-userid'], $_FORM['txtUserID'], 1, 1000000, TRUE);

      $strSQL2="DELETE FROM $TABLE_USERS WHERE user_id='$strUserID'";
      $result2=dbquery($strSQL2);
      $strSQL3="DELETE FROM $TABLE_ACCESSTIMES WHERE user_id='$strUserID'";
      $result3=dbquery($strSQL3);
      $strSQL4="DELETE FROM $TABLE_PROJECT_ACCESS WHERE user_id='$strUserID'";
      $result4=dbquery($strSQL4);
      $strSQL5="DELETE FROM $TABLE_TICKET_DIST WHERE user_id='$strUserID'";
      $result5=dbquery($strSQL5);
      $strSQL6="DELETE FROM $TABLE_PROJECT_DIST WHERE user_id='$strUserID'";
      $result6=dbquery($strSQL6);
      $strError = $LA['au-user']." ($strUserID) ".$LA['au-deleted'].".<BR>";
      //$strError.= "(User / AccessTimes / ProjectAccesses / Ticket & Project Distributions)";
      $strUserID=NULL; // back to the default page
    }
  }
  else if ($strUserID==-1 && $_FORM['txtUsername']) // creating a new user
  {
    $strUserID     = validateNumber($LA['au-userid'], $_FORM['txtUserID'], 1, 1000000, TRUE);
    $strUsername     = validateText($LA['au-username'], $_FORM['txtUsername'], 1, 40, TRUE, FALSE);
    $strFirstName    = validateText($LA['au-first'], $_FORM['txtFirstName'], 2, 40, TRUE, FALSE);
    $strLastName     = validateText($LA['au-last'], $_FORM['txtLastName'], 2, 40, TRUE, FALSE);
    $strEmail        = validateEmail($LA['au-email'], $_FORM['txtEmail'], FALSE);
    $strPhone        = validateText($LA['au-phone'], $_FORM['txtPhone'], 4, 25, FALSE, FALSE);
    $strPassword1    = validateText($LA['au-pword1'], $_FORM['txtPassword1'], 6, 20, FALSE, FALSE);
    $strPassword2    = validateText($LA['au-pword2'], $_FORM['txtPassword2'], 6, 20, FALSE, FALSE);
    $strFrameMode    = validateText($LA['au-frame'], $_FORM['txtFrameMode'], 1, 1, FALSE, FALSE);
    $strView         = validateText($LA['au-view'], $_FORM['txtView'], 1, 40, FALSE, FALSE);
    $strCorder       = validateText($LA['au-corder'], $_FORM['txtCorder'], 1, 40, FALSE, FALSE);
    $strRorder       = validateText($LA['au-rorder'], $_FORM['txtRorder'], 1, 40, FALSE, FALSE);
    $strDBadmin      = validateText($LA['au-dbflag'], $_FORM['txtDBadmin'], 1, 1, FALSE, FALSE);
    $strNotify       = validateText($LA['au-notify'], $_FORM['txtNotify'], 1, 1, FALSE, FALSE);

    $new_password="";
    $strTempString = "ABCDEFGHIJKLMNPQRSTUVWXYZ123456789";
    for ($i = 0; $i < 8; $i++)
    {
      $intPos = rand(0, 33);
      $strTempChar = substr($strTempString, $intPos, 1);
      $new_password.=$strTempChar;
    }

    /*
     * We must determine if there is already a user by this name taken.
     */
    $strSQL6A ="SELECT user_id FROM $TABLE_USERS WHERE username='$strUsername'";
    $result6A=dbquery($strSQL6A);
    if($row6A=mysql_fetch_array($result6A))
    {
      $strError.="<BR>".$LA['au-error-user']." '$strUsername' ".$LA['au-is-taken'].".<BR>\n";
    }
    else
    {
      $strSQL6 ="INSERT INTO $TABLE_USERS SET ";
      $strSQL6.="  username='$strUsername'";
      $strSQL6.=", first_name='$strFirstName'";
      $strSQL6.=", last_name='$strLastName'";
      $strSQL6.=", email='$strEmail'";
      $strSQL6.=", phone='$strPhone'";
      $strSQL6.=", password='".md5($new_password)."'";
      $strSQL6.=", passworddate='".date(U)."'";
      $strSQL6.=", activated_account='1'";
      $strSQL6.=", db_admin='$strDBadmin'";
      $strSQL6.=", account_create_date='".date(U)."'";
      $result6=dbquery($strSQL6);
      $strSQL7 ="SELECT user_id FROM $TABLE_USERS WHERE username='$strUsername'";
      $result7=dbquery($strSQL7);
      $row7=mysql_fetch_array($result7);
      $strUserID=$row7['user_id']; // so bottom of this page will show this user just created

      $strError.= "<BR>".$LA['au-userid']." $strUserID ".$LA['au-created'].".";
      $msgBody = $LA['au-from'].": ".makeHomeURL()."<BR>\n";
      $msgBody.= " - ".$LA['au-username'].": $strUsername<BR>\n";
      $msgBody.= " - ".$LA['au-name'].": $strFirstName $strLastName<BR>\n";
      $msgBody.= " - ".$LA['au-email'].": $strEmail<BR>\n";
      $msgBody.= " - ".$LA['au-phone'].": $strPhone<BR>\n";
      $msgBody.= " - ".$LA['au-pword'].": $new_password<BR>\n";
      $msgBody.= " - ".$LA['au-view'].": $strView<BR>\n";
      $msgBody.= " - ".$LA['au-frame'].": $strFrameMode<BR>\n";
      $msgBody.= $LA['au-if-not']." $adminEmail.";
      if($strEmail)
      {
        mail($strEmail,$LA['au-edit-msg'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);
        $strError.= "<BR>".$LA['au-pword-sent']." $strEmail.";
      }
      else
      {
        mail($adminEmail,$LA['au-edit-msg'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);
        $strError.= "<BR>".$LA['au-pword-sent']." $adminEmail.";
      }
    }
  }
  else if ($_FORM['btnSubmit'] && $_FORM['txtUserID'])
  {
    // if data was submitted ... to edit a user ID
    $strUserID     = validateNumber($LA['au-userid'], $_FORM['txtUserID'], 1, 1000000, FALSE);
    $strUsername     = validateText($LA['au-username'], $_FORM['txtUsername'], 1, 40, TRUE, FALSE);
    $strFirstName    = validateText($LA['au-first'], $_FORM['txtFirstName'], 2, 40, TRUE, FALSE);
    $strLastName     = validateText($LA['au-last'], $_FORM['txtLastName'], 2, 40, TRUE, FALSE);
    $strEmail        = validateEmail($LA['au-email'], $_FORM['txtEmail'], FALSE);
    $strPhone        = validateText($LA['au-phone'], $_FORM['txtPhone'], 4, 25, FALSE, FALSE);
    $strPassword1    = validateText($LA['au-pword1'], $_FORM['txtPassword1'], 6, 20, FALSE, FALSE);
    $strPassword2    = validateText($LA['au-pword2'], $_FORM['txtPassword2'], 6, 20, FALSE, FALSE);
    $strDBadmin      = validateText($LA['au-dbflag'], $_FORM['txtDBadmin'], 1, 1, FALSE, FALSE);
    $strNotify       = validateText($LA['au-notify'], $_FORM['txtNotify'], 1, 1, FALSE, FALSE);
    $strGuest        = validateNumber($LA['au-guest-flag'], $_FORM['txtGuest'], 0, 1, FALSE);
    if ($strError == "")
    {
      if ($strPassword1 != $strPassword2)
      {
        $strError = $LA['au-pword-msg'];
      }
      else
      {
        $strSQL0 = "SELECT email FROM $TABLE_USERS WHERE user_id='$strUserID'";
        $result0 = dbquery($strSQL0);
        $row0    = mysql_fetch_array($result0);
        $strOldEmail=$row0['email'];

        $strSQL1 = "UPDATE $TABLE_USERS SET";
        $strSQL1.= " first_name='$strFirstName'";
        $strSQL1.= ", last_name='$strLastName'";
        $strSQL1.= ", email='$strEmail'";
        $strSQL1.= ", phone='$strPhone'";
        $strSQL1.= ", frame_mode='$strFrameMode'";
        $strSQL1.= ", c_order='$strCorder'";
        $strSQL1.= ", r_order='$strRorder'";
        $strSQL1.= ", db_admin='$strDBadmin'";
        $strSQL1.= ", guest='$strGuest'";
        $strSQL1.= " WHERE user_id='$strUserID'";
        $result1 = dbquery($strSQL1);
        $strError = $LA['au-update-success'];

        if($strNotify)
        {
          $msgBody = $LA['au-from'].": ".makeHomeURL()."<BR>\n";
          $msgBody.= " - ".$LA['au-username'].": ".$row2['username']."<BR>\n";
          $msgBody.= " - ".$LA['au-name'].": $strFirstName $strLastName<BR>\n";
          $msgBody.= " - ".$LA['au-email'].": $strEmail<BR>\n";
          $msgBody.= " - ".$LA['au-phone'].": $strPhone<BR>\n";
          $msgBody.= " - ".$LA['au-view'].": $strView<BR>\n";
          $msgBody.= $LA['au-if-not']." $adminEmail.";
          mail($strEmail,$LA['au-edit-msg'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);
          $strError.="<BR>".$LA['au-mail-notice'].": $strEmail";
  
          if ($strEmail != $strOldEmail && $strOldEmail)
          {
            mail($strOldEmail, $LA['au-edit-msg'].": ".date("m-d-Y"), $msgBody, $MAIL_HEADER);
            $strError.="<BR>".$LA['au-andto'].": $strOldEmail";
          }
        }
      }
    }
  } 
  else if($_FORM['createSubmit'])
  {
    $strUserID="-1";
  }
  else
  {
    if($DEBUG)print "No Submit<BR>";
    $strUserID = validateNumber($LA['au-userid'], $_FORM['txtUserID'], 1, 1000000, FALSE);

    if(!$strUserID)
    {
      // admin must select a user(id) to edit
      writeHeader($LA['au-select-user']);
      declareError(TRUE);

      if($_FORM['searchSubmit'])
      {
        $TOP_SELECT ="<form class=forms name='form2' onsubmit='return(document.form2.txtUserID.selectedIndex>0);' method='POST' action='".$_SERVER['PHP_SELF']."'>";
        $TOP_SELECT.="<br><table class=wrap cellpadding='0' cellspacing=0><tr><td>";
        $TOP_SELECT.="<table class=forms border='0' cellpadding='2'>";
        $TOP_SELECT.="<tr><td colspan=2 align=center>".$LA['au-choose-user']."</td></tr>";
        $TOP_SELECT.="<tr> <td >Username:</td> <td ><select name='txtUserID' class=forms>";
        $TOP_SELECT.="<option value=''>".$LA['au-choose-user']."</option>\n";
        $BOT_SELECT.=" </select></td>\n </tr>\n";
        $BOT_SELECT.="<tr><td colspan=2 align=center>";
        $BOT_SELECT.="<input class=form_button type='submit' value='".$LA['au-edit']."Edit' name='searchSubmit'> ";
        $BOT_SELECT.="<input class=form_button type='reset' value='".$LA['au-reset']."Reset' name='reset'> ";
        $BOT_SELECT.="<input class=form_button id=b1 type='button' onclick=\"if(this.form.txtUserID.selectedIndex==0)return;this.form.delSub2.tag=1;document.getElementById('b2').className='form_button';document.getElementById('b1').className='form_button2';\" value='".$LA['au-del1']."' name='delSub1'>";
        $BOT_SELECT.="<input class=form_button2 id=b2 type='button' onclick=\"if(this.tag){this.form.deleteSubmit.value=1;this.form.submit();}\" tag=0 value='".$LA['au-del-user']."' name='delSub2'>";
        $BOT_SELECT.="<input type=hidden name='deleteSubmit' value='0'>";
        $BOT_SELECT.="</td></tr></table>";
        $BOT_SELECT.="</td></tr></table>";
        $BOT_SELECT.=" </form>\n";
  
        $temp="";
        $strQ2 ="SELECT user_id,username,first_name,last_name from $TABLE_USERS WHERE";
        /* for better security */
        $strEmail        = validateEmail($LA['au-email'], $_FORM['txtEmail'], FALSE);
        $strUsername     = validateText($LA['au-username'], $_FORM['txtUsername'], 1, 40, TRUE, FALSE);
        $strFirstName    = validateText($LA['first'], $_FORM['txtFirstName'], 2, 40, TRUE, FALSE);
        $strLastName     = validateText($LA['last'], $_FORM['txtLastName'], 2, 40, TRUE, FALSE);
        if(strlen($strEmail)    >1) { $strQ2.=" $temp email like \"%".$strEmail."%\"";          $temp="AND"; }
        if(strlen($strUsername) >1) { $strQ2.=" $temp username like \"%".$strUsername."%\"";    $temp="AND"; }
        if(strlen($strFirstName)>1) { $strQ2.=" $temp first_name like \"%".$strFirstName."%\""; $temp="AND"; }
        if(strlen($strLastName) >1) { $strQ2.=" $temp last_name like \"%".$strLastName."%\"";   $temp="AND"; }
        if(!$temp) // we know we are looking for at least one attribute...
        {
          $strQ2="SELECT user_id,username,first_name,last_name FROM $TABLE_USERS";
        }
        $strQ2.=" ORDER BY username";
        if($resultQ2=dbquery($strQ2))
        {
          print $TOP_SELECT;
          while($rowQ2=mysql_fetch_array($resultQ2))
          {
            print "<option value='".$rowQ2['user_id']."'>";
            print $rowQ2['username']." (".$rowQ2['user_id'].")  - ".$rowQ2['last_name'].", ".$rowQ2['first_name'];
            print "</option>\n";
          }
          print $BOT_SELECT;
        }
      }
    
      // search for user to edit by:
      //  - firstname, lastname, username, emailaddress, userid
?>
<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<table cellpadding=0 cellspacing=0 class=wrap><tr><td>
  <br><table class=forms border='0' cellpadding='2'>
    <tr><td colspan=2 align=center><?=$LA['au-enter-msg'];?></td></tr>
    <tr>
      <td ><?=$LA['au-username'];?>:</td>
      <td ><input class=forms type="text" name="txtUsername" value="" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['au-first'];?>:</td>
      <td ><input class=forms type="text" name="txtFirstName" value="" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['au-last'];?>:</td>
      <td ><input class=forms type="text" name="txtLastName" value="" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['au-email'];?>:</td>
      <td ><input class=forms type="text" name="txtEmail" value="" size="40" maxlength="50"></td>
    </tr>
    <tr><td colspan=2 align=center>
      <input class=form_button type="submit" value="<?=$LA['au-search'];?>" name="searchSubmit">
      <input class=form_button type="reset" value="<?=$LA['au-reset'];?>" name="reset">
    </td></tr></table>
  </td></tr></table>
</form>

<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<table align=center class=forms cellspacing=0 cellpadding=3>
<tr><td align=center><input class=form_button type=submit value="<?=$LA['au-create-new'];?>" name="createSubmit"></td></tr>
</table>
</form>
<?
  print "<br><BR>";
  writeFooter();
      exit;
    }
  }
  if($strUserID && $strUserID!=-1)
  {
    $strSQL2 = "SELECT * FROM $TABLE_USERS WHERE user_id=".$strUserID;
    $result2= dbquery($strSQL2);
    $row2= mysql_fetch_array($result2);

    $strUsername       = $row2['username'];
    $strFirstName      = $row2['first_name'];
    $strLastName       = $row2['last_name'];
    $strEmail          = $row2['email'];
    $strPhone          = $row2['phone'];
    $strPassworddate   = $row2['passworddate'];
    $strFrameMode      = $row2['frame_mode']; if($strFrameMode)$SEL_YES="SELECTED";else $SEL_NO="SELECTED";
    $strView           = $row2['view'];
    $strCorder         = $row2['c_order'];
    $strRorder         = $row2['r_order'];
    $strAccountCreated = $row2['account_create_date'];
    $strDBAdmin        = $row2['db_admin'];
    $strSuccBadPass    = $row2['succ_badpass'];
    $strNumBadPass     = $row2['num_badpass'];
    $strNumLogouts     = $row2['num_logouts'];
    $strNumLogins      = $row2['num_logins'];
    $strLastBadPass    = $row2['last_badpass'];
    $strLastLogout     = $row2['last_logout'];
    $strLastLogin      = $row2['last_login'];
    $strDBadmin        = $row2['db_admin']; if($strDBadmin)$ADMIN_YES="SELECTED";else $ADMIN_NO="SELECTED";
    $strGuest          = $row2['guest'];  if($strGuest)$GUEST_YES="CHECKED";else $GUEST_NO="CHECKED";
  }

  writeHeader($LA['au-admin-users']);
  declareError(TRUE);

if($strUserID)
{
  $tempStrUserId=$strUserID;
  if($tempStrUserId==-1){$tempStrUserId="N/A";}
  if(!$GUEST_YES)$GUEST_NO="CHECKED";
?>
<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<input type=hidden name="txtUserID" value="<?=$strUserID;?>">
  <br><table class=forms border='0' cellpadding='2'>
    <tr><td ><?=$LA['au-username'];?>: (<?=$tempStrUserId;?>)</td><td><input type=text name="txtUsername" value="<?=$strUsername;?>"></td></tr>
    <tr><td><?=$LA['au-guest-only'];?></td>
        <td><?=$LA['au-guest'];?>:<input <?=$GUEST_YES;?> type=radio name="txtGuest" value="1">
            <?=$LA['au-rguest'];?>Real User:<input <?=$GUEST_NO;?> type=radio name="txtGuest" value=""></td></tr>
    <tr><td ><?=$LA['au-user-dbadmin'];?>:</td>
        <td>
          <select name="txtDBadmin" class=forms><option <?=$ADMIN_NO;?> value="0"><?=$LA['au-no'];?></option><option <?=$ADMIN_YES;?> value="1"><?=$LA['au-yes'];?></option></select>
        </td></tr>
<? if($strUserID!=-1) { ?>
    <tr><td ><?=$LA['au-account-created'];?>:</td><td><?=printDate2($strAccountCreated);?></td></tr>
    <tr><td ><?=$LA['au-pword-date'];?>:</td><td><?=printDate2($strPassworddate);?></td></tr>
    <tr><td ><?=$LA['au-last-login'];?>:</td><td><?=printDate2($strLastLogin);?> - Total (<?=$strNumLogins;?>)</td></tr>
    <tr><td ><?=$LA['au-last-logout'];?>:</td><td><?=printDate2($strLastLogout);?> - Total (<?=$strNumLogouts;?>)</td></tr>
    <tr><td ><?=$LA['au-last-bpass'];?>:</td><td><?=printDate2($strLastBadPass);?>  - Total (<?=$strSuccBadPass;?>/<?=$strNumBadPass;?>)</td></tr>
<? } ?>
    <tr>
      <td ><?=$LA['au-first'];?>:</td>
      <td ><input class=forms type="text" name="txtFirstName" value="<?echo $strFirstName;?>" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['au-last'];?>:</td>
      <td ><input class=forms type="text" name="txtLastName" value="<?echo $strLastName;?>" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['au-email'];?>:</td>
      <td ><input class=forms type="text" name="txtEmail" value="<?echo $strEmail;?>" size="40" maxlength="50"></td>
    </tr>
<? if($strUserID!=-1 && $CURRENT_USER['ID'] ==$strUserID) { ?>
    <tr>
      <td ><?=$LA['au-pword'];?>:</td><td><input type=password class=forms name="txtPassword1" size="40" maxlength="20"></td>
    </tr>
    <tr>
      <td ><?=$LA['au-vpword'];?>:</td><td><input type=password class=forms name="txtPassword2" size="40" maxlength="20"></td>
    </tr>
<? } ?>
    <tr>
      <td ><?=$LA['au-phone'];?>:</td><td><input type=text class=forms name="txtPhone" size="20" value="<?=$strPhone;?>" maxlength="20"></td>
    </tr>
<? if($strUserID!=-1) { ?>
    <tr>
      <td ><?=$LA['au-notify-onchange'];?>:</td><td><input type=checkbox class=forms name="txtNotify" value='1'><?=$LA['au-yes-ifckd'];?>.</td>
    </tr>
<? } ?>
    <tr><td colspan=2 align=center>
      <input class=form_button type="submit" value="<?=$LA['au-commit'];?>" name="btnSubmit">
      <input class=form_button type="reset" value="<?=$LA['au-reset'];?>" name="reset">
<? if($strUserID!=-1) { ?>
      <input class=form_button id=b1 type="button" onclick="this.form.delSub2.tag=1;document.getElementById('b2').className='form_button';document.getElementById('b1').className='form_button2';" value="<?=$LA['au-del1'];?>" name="delSub1">
      <input class=form_button2 id=b2 type="button" onclick="if(this.tag){this.form.deleteSubmit.value=1;this.form.submit();}" tag=0 value="<?=$LA['au-del-user'];?>" name="delSub2">
      <input type=hidden name="deleteSubmit" value="0">
<? } ?>
    </td></tr></table>
</form>

<?
}
  print "<br><BR>";
  writeFooter();
?>
