<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/


  include("config/global.inc.php");
  checkPermissions(1, $SESSION_TIMEOUT); // user logged in? - keep session alive...

  // non admins go bye-bye
  if(!$CURRENT_USER['IS_A_DB_ADMIN'] && !$CURRENT_USER['IS_A_PROJECT_ADMIN'])
  {
    redirect("index.php");
    exit;
  }


  $strProjectID = validateNumber($LA['pi-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
  if($_FORM['txtDelID'] && ( $CURRENT_USER['IS_A_DB_ADMIN'] || $CURRENT_USER['PROJECT_ADMIN'][$strProjectID]))
  {
    $strDelID     = validateNumber($LA['pi-item-num'],    $_FORM['txtDelID'],  1, 1000, TRUE);
    $strDelF      = validateNumber($LA['pi-item1'],     $_FORM['txtDelF'],  1, 1000, TRUE);
    $strDelD      = validateNumber($LA['pi-item2'],    $_FORM['txtDelD'],  1, 1000, TRUE);
    $strDelV      = validateText($LA['pi-dep-value'], $_FORM['txtDelV'],    1, 11, FALSE, FALSE);
    if(!$strError)
    {
      if(isset($strDelV) && $strDelV!="")
        $strSQL1="DELETE FROM $TABLE_ITEM_DEPENDENCY WHERE rule_id='$strDelF' AND drule_id='$strDelD' AND value like '$strDelV'";
      else
        $strSQL1="DELETE FROM $TABLE_ITEM_DEPENDENCY WHERE rule_id='$strDelF' AND drule_id='$strDelD' AND value IS NULL";
      $result1=dbquery($strSQL1);
      $strError=$LA['pi-item-del-success']." ($strDelID)";
    }
  }

  /* this will remember the project as last project */
  if(isset($_FORM['txtProjectID']))
    $_SESSION['LastProject']=$strProjectID;


  if($_FORM['btnAddItem'] && ( $CURRENT_USER['IS_A_DB_ADMIN'] || $CURRENT_USER['PROJECT_ADMIN'][$strProjectID]))
  {
    $strProjectID = validateNumber($LA['pi-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
    $strFirstItem     = validateNumber($LA['pi-item1'],     $_FORM['txtFirstItem'],  1, 1000, TRUE);
    $strSecondItem    = validateNumber($LA['pi-item2'],     $_FORM['txtSecondItem'],  1, 1000, TRUE);
    $strDependValue   = validateText($LA['pi-del-value'],    $_FORM['txtDependValue'],    1, 11, FALSE, FALSE);
    if(!$strError && $strFirstItem==$strSecondItem){$strError=$LA['pi-error1'];}
    if(!$strError)
    {
      $strSQL1 ="INSERT INTO $TABLE_ITEM_DEPENDENCY SET ";
      $strSQL1.="  rule_id='$strFirstItem'";
      $strSQL1.=", drule_id='$strSecondItem'";
      if(isset($strDependValue) && $strDependValue!="")
      {
        $strSQL1.=", value='$strDependValue'";
      }
      $result1=dbquery($strSQL1);
      $strError=$LA['pi-success1'];
    }
  }

  if($_FORM['deleteSubmit'] && ( $CURRENT_USER['IS_A_DB_ADMIN'] || $CURRENT_USER['PROJECT_ADMIN'][$strProjectID]))
  { 
    $strProjectID = validateNumber($LA['pi-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
    $strDeleteItem    = validateNumber($LA['pi-item-to-del'],     $_FORM['txtDeleteItem'],  1, 1000, TRUE);
    if(!$strError)
    {
      $strSQL1="DELETE FROM $TABLE_ITEM_DEPENDENCY WHERE rule_id='$strDeleteItem' OR drule_id='$strDeleteItem'";
      $result1=dbquery($strSQL1);
      $strSQL2="DELETE FROM $TABLE_ITEM_TO_PROJECT WHERE rule_id='$strDeleteItem'";
      $result2=dbquery($strSQL2);
      $strError.=$LA['pi-item-del-success']." ($strDeleteItem)"; // [with any dependicies removed].";
    }
  } 
  else if ($_FORM['btnSubmit']==$LA['pi-perf-action'])
  {
    if($_FORM['txtAddItemType'] && ( $CURRENT_USER['IS_A_DB_ADMIN'] || $CURRENT_USER['PROJECT_ADMIN'][$strProjectID]))
    {
      $strProjectID = validateNumber($LA['pi-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
      $strAddItemLabel   = validateText($LA['pi-item-label'],    $_FORM['txtAddItemLabel'], 2, 40, TRUE, TRUE);
      $strAddItemType    = validateNumber($LA['pi-item-type'],     $_FORM['txtAddItemType'],  0, 1000, TRUE);
      $strAddItemDefault = validateText($LA['pi-def-value'], $_FORM['txtDefaultValue'], 0, 40, FALSE, FALSE);

      if(!$strError)
      {
        $strSQL5 ="SELECT rule_id FROM $TABLE_ITEM_TO_PROJECT WHERE type_id='$strAddItemType' AND project_id='$strProjectID' AND label LIKE '$strAddItemLabel'";
        $result5=dbquery($strSQL5);
        if($row5=mysql_fetch_array($result5))
        {
          $strError=$LA['pi-error2']."<BR>\n";
        }
        else
        {
          $strSQL6 ="INSERT INTO $TABLE_ITEM_TO_PROJECT SET ";
          $strSQL6.="  type_id='$strAddItemType'";
          $strSQL6.=", project_id='$strProjectID'";
          $strSQL6.=", label='$strAddItemLabel'";
          if(isset($strAddItemDefault) && $strAddItemDefault!="")
          {
            $strSQL6.=", default_value='$strAddItemDefault'";
          }
          $result6=dbquery($strSQL6);
          $strSQL7 ="SELECT rule_id FROM $TABLE_ITEM_TO_PROJECT WHERE type_id='$strAddItemType' AND project_id='$strProjectID' AND label LIKE '$strAddItemLabel'";
          $result7=dbquery($strSQL7);
          $row7=mysql_fetch_array($result7);
          $strRuleID=$row7['rule_id']; // so bottom of this page will show this project just created
          $strError = $LA['pi-item-inserted-success']." - $strAddItemLabel ($strRuleID)";
        }
      }
    } 
    if($_FORM['txtEditItem'] && ( $CURRENT_USER['IS_A_DB_ADMIN'] || $CURRENT_USER['PROJECT_ADMIN'][$strProjectID]))
    {
      $strProjectID = validateNumber($LA['pi-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
      $strEditItem    = validateNumber($LA['pi-item-to-edit'],     $_FORM['txtEditItem'],  1, 1000, TRUE);
      if(!$strError)
      {
        if($_FORM['txtEditItem2'] && !$_FORM['txtAddEnum'] && !$_FORM['txtDelEnum'])
        {
          ## commit changes
          $strItemLabel   = validateText($LA['pi-label'],    $_FORM['txtItemLabel'],    1, 11, TRUE, TRUE);
          $strItemDefault = validateText($LA['pi-default'],  $_FORM['txtItemDefault'],  1, 11, TRUE, TRUE);

          $strSQL1 = "UPDATE $TABLE_ITEM_TO_PROJECT SET";
          $strSQL1.= " label='$strItemLabel'";
          $strSQL1.= ", default_value='$strItemDefault'";
          $strSQL1.= " WHERE rule_id='$strEditItem'";
          $result1 = dbquery($strSQL1);
          $strError = $LA['pi-item-update-success'];
        }
        else
        {
echo $LA['pi-edit-enum'].":<BR>\n";
          if($_FORM['txtDelEnum'])
          {
echo $LA['pi-del-enum']." $txtDelEnum<BR>\n";
            $strSQL1="DELETE FROM $TABLE_ITEM_ENUMS WHERE value='$txtDelEnum'";
            $result1=dbquery($strSQL1);
            $strError=$LA['pi-success-del']." ($txtDelEnum)";
          }
          else if($_FORM['txtAddEnum'])
          {
            if(!$_FORM['txtaddenummove'])
            {
              $strAddEnum = validateText($LA['pi-enum-to-add'],  $_FORM['txtAddEnum'],  1, 11, TRUE, TRUE);

              $strSQL6 ="INSERT INTO $TABLE_ITEM_ENUMS SET ";
              $strSQL6.="  the_order='1'";
              $strSQL6.=", rule_id='$strEditItem'";
              $strSQL6.=", value='$strAddEnum'";
              $result6=dbquery($strSQL6);
            }
            else
            {
              $strSQL6 = "UPDATE $TABLE_ITEM_ENUMS SET";
              $strSQL6.= " the_order='".$_FORM['txtaddenummove']."'";
              $strSQL6.= " WHERE rule_id='$strEditItem' AND value LIKE '".$_FORM['txtAddEnum']."'";
              $result6 = dbquery($strSQL6);
            }
            
          }
          $strSQL7 ="SELECT * FROM $TABLE_ITEM_TO_PROJECT AS A,$TABLE_ITEM_TYPE AS B WHERE A.rule_id='$strEditItem' AND A.type_id=B.type_id";
          $result7=dbquery($strSQL7);
          $row7=mysql_fetch_array($result7);
          $strItemLabel=$row7['label'];
          $strItemDefault=$row7['default_value'];
          $strItemType=$row7['type'];
      writeHeader($LA['pi-header1'].": $strItemType");
      declareError(TRUE);
?>
<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<input type=hidden name="txtProjectID" value="<?=$strProjectID;?>">
<input type=hidden name="txtEditItem" value="<?=$strEditItem;?>">
<input type=hidden name="txtEditItem2" value="<?=$strEditItem;?>">
<input type=hidden name="txtaddenummove" value="0">
<input type=hidden name="txtDelEnum" value="">
<input type=hidden name="btnSubmit" value="<?=$LA['pi-perf-action'];?>">
<table class=wrap align=center>
<tr><td><?=$LA['pi-label'];?>:</td><td><input type=text name="txtItemLabel" value="<?=$strItemLabel;?>"></td></tr>
<tr><td><?=$LA['pi-default'];?>:</td><td><input type=text name="txtItemDefault" value="<?=$strItemDefault;?>"></td></tr>
<?
if($row7['type']=="Date")
{
  echo "<tr><td align=center colspan=2>".$LA['pi-date-msg']."</td></tr>\n";
}
if($row7['type']=="Person")
{
  // note this only indicates to default to person creating the ticket
  echo "<tr><td align=center colspan=2>".$LA['pi-person-msg']."</td></tr>\n";
}
if($row7['type']=="Enum" || $row7['type']=="Choice") // added for Choice
{
$whichType=$row7['type'];
echo "<tr><td align=center colspan=2>$whichType-".$LA['pi-type=msg']."</td></tr>\n";

echo "<tr><td>$whichType:</td><td>";
echo "<table class=wrap>";
echo "<tr><td align=center>".$LA['pi-move']."</td><td align=center>$whichType ".$LA['pi-value']." [".$LA['pi-order']."]</td><td>".$LA['pi-delete']."</td></tr>\n";
$strSQL8 ="SELECT * FROM $TABLE_ITEM_ENUMS WHERE rule_id='$strEditItem' ORDER BY the_order,value";
$result8=dbquery($strSQL8);
while($row8=mysql_fetch_array($result8))
{
$up=1+$row8['the_order'];
$down=-1+$row8['the_order'];
echo "<tr><TD>";
echo "<a href='javascript:";
echo "document.form1.txtaddenummove.value=\"$up\";";
echo "document.form1.txtAddEnum.value=\"".$row8['value']."\";";
echo "document.form1.submit();'>+</a>";
echo "/";
echo "<a href='javascript:";
echo "document.form1.txtaddenummove.value=\"$down\";";
echo "document.form1.txtAddEnum.value=\"".$row8['value']."\";";
echo "document.form1.submit();'>-</a>";
echo "</td>";
echo "<TD>".$row8['value']." [".$row8['the_order']."]</td>";
echo "<td><a href='javascript:document.form1.txtDelEnum.value=\"".$row8['value']."\";document.form1.submit();'>".$LA['pi-deletejs']."</a></td>";
echo "</tr>\n";
}

echo "<tr><td>".$LA['pi-add']."+</td><td><input type=text name=txtAddEnum></td><td>+".$LA['pi-add']."</tr></tr>";
echo "</table>";
echo "</td></tr>";

}
?>
<tr><td colspan=2 align=center><input type=submit value="<?=$LA['pi-commit'];?>" class=form_button></td></tr>
</td></tr></table>
</form>
<form class=forms name="form2" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<input type=hidden name="txtProjectID" value="<?=$strProjectID;?>">
<input class=form_button value="<?=$LA['pi-return-to-items'];?>" type=submit>
</form>
<?
  print "<BR><BR>";
  writeFooter();
  exit;
        }
      }
    }
  }
  else
  {
    $strProjectID = validateNumber($LA['pi-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
    if(!$strProjectID)
    {
      // admin must select a project(id) to work with Items
      writeHeader($LA['pi-header2']);
      declareError(TRUE);

      if($_FORM['searchSubmit'])
      {
        $TOP_SELECT ="<form class=forms name='form2' method='POST' onsubmit='return(document.form2.txtProjectID.selectedIndex>0);' action='".$_SERVER['PHP_SELF']."'>";
        $TOP_SELECT.="<br><table class=wrap cellpadding='0' cellspacing=0><tr><td>";
        $TOP_SELECT.="<table class=forms border='0' cellpadding='2'>";
        $TOP_SELECT.="<tr><td colspan=2 align=center>".$LA['pi-choose-project']."</td></tr>";
        $TOP_SELECT.="<tr> <td >Project:</td> <td ><select name='txtProjectID' class=forms>";
        $TOP_SELECT.="<option value=''>".$LA['pi-choose-project']."</option>\n";
        $BOT_SELECT.=" </select></td>\n </tr>\n";
        $BOT_SELECT.="<tr><td colspan=2 align=center>";
        $BOT_SELECT.="<input class=form_button type='submit' value='".$LA['pi-edit-items']."' name='searchSubmit'> ";
        $BOT_SELECT.="<input class=form_button type='reset' value='".$LA['pi-reset']."' name='reset'> ";
        $BOT_SELECT.="</td></tr></table>";
        $BOT_SELECT.="</td></tr></table>";
        $BOT_SELECT.=" </form>\n";

        $temp="";
        $temp2="";
        $temp3="";
        if(!$CURRENT_USER['IS_A_DB_ADMIN'])
        {
          $temp2=", $TABLE_PROJECT_ACCESS as A";
          $temp3=" AND A.project_id=P.project_id AND A.level>=".$PROJECT_ACCESS['admin'];
          $temp4=" WHERE A.user_id='".$CURRENT_USER['ID']."' AND A.project_id=P.project_id AND A.level>=".$PROJECT_ACCESS['admin'];
        }
        $strQ2 ="SELECT P.project_id,P.project_name from $TABLE_PROJECTS AS P $temp2 WHERE";
        if(strlen($_FORM['txtName'])  >1) { $strQ2.=" $temp P.project_name      like \"%".$_FORM['txtName']."%\"";   $temp="AND"; }
        if(strlen($_FORM['txtEmail']) >1) { $strQ2.=" $temp P.mail_alias        like \"%".$_FORM['txtEmail']."%\"";  $temp="AND"; }
        if(strlen($_FORM['txtAbbrev'])>1) { $strQ2.=" $temp P.project_abbr      like \"%".$_FORM['txtAbbrev']."%\""; $temp="AND"; }
        if(!$temp) // we know we are looking for at least one attribute...
        {
          $strQ2="SELECT P.project_id,P.project_name FROM $TABLE_PROJECTS AS P $temp2 $temp4 ORDER BY project_name"; 
        }
        else
        {
          $strQ2.=" $temp3 ORDER BY project_name";
        }
	  //echo "Q:<DIR>$strQ2</DIR>";
          if($resultQ2=dbquery($strQ2))
          {
            print $TOP_SELECT;
            while($rowQ2=mysql_fetch_array($resultQ2))
            {
              print "<option value='".$rowQ2['project_id']."'>";
              print $rowQ2['project_name']." (".$rowQ2['project_id'].")";
              print "</option>\n";
            }
            print $BOT_SELECT;
        }
     }
    
?>
<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<table cellpadding=0 cellspacing=0 class=wrap><tr><td>
  <br><table class=forms border='0' cellpadding='2'>
    <tr><td colspan=2 align=center><?=$LA['pi-select-proj-msg'];?>:</td></tr>
    <tr>
      <td ><?=$LA['pi-project-name'];?>:</td>
      <td ><input class=forms type="text" name="txtName" value="" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['pi-project-abrev'];?>:</td>
      <td ><input class=forms type="text" name="txtAbbrev" value="" size="10" maxlength="10"></td>
    </tr>
    <tr>
      <td ><?=$LA['pi-email'];?>:</td>
      <td ><input class=forms type="text" name="txtEmail" value="" size="40" maxlength="50"></td>
    </tr>
    <tr><td colspan=2 align=center>
      <input class=form_button type="submit" value="<?=$LA['pi-search'];?>" name="searchSubmit">
      <input class=form_button type="reset" value="<?=$LA['pi-reset'];?>" name="reset">
    </td></tr></table>
  </td></tr></table>
</form>
<BR><BR>

<?
  print "<BR><BR>";
  writeFooter();
      exit;
    }
  }
  if($strProjectID && $strProjectID!=-1)
  {
    $strSQL2 = "SELECT * FROM $TABLE_PROJECTS WHERE project_id='$strProjectID'";
    $result2= dbquery($strSQL2);
    $row2= mysql_fetch_array($result2);

    $strName       = $row2['project_name'];
    $strEmail      = $row2['mail_alias'];
    $strAbbrev     = $row2['project_abbr'];
    $strAnyone     = $row2['allowanyonecreate']; if($strAnyone)$SEL_YES="SELECTED";else $SEL_NO="SELECTED";
  }

  writeHeader($LA['pi-edit-proj-items']);
  declareError(TRUE);

if($strProjectID)
{
## if we get here - then the user has selected the Project to edit/delete/add Items into/from ##

?>

<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<input type=hidden name="txtProjectID" value="<?=$strProjectID;?>">
<br>
<table class=forms border='0' cellpadding='2'>
    <tr>
      <td ><?=$LA['pi-project-name'];?> [<?=$LA['pi-alias'];?>]:</td>
      <td ><?=$strName;?> [<?=$strAbbrev;?>]</td>
    </tr>
</table>
<table class=wrap border='0' cellpadding='2'>
<tr>
<td><?=$LA['pi-edit-item'];?>:</td>
<td>
<select class=forms name="txtEditItem">
<option value=""><?=$LA['pi-choose'];?></option>
<?
$strSQL = "SELECT A.rule_id, A.label, B.type";
$strSQL.= " FROM ($TABLE_ITEM_TO_PROJECT AS A";
$strSQL.= " , $TABLE_ITEM_TYPE AS B)";
$strSQL.= " WHERE project_id='$strProjectID'";
$strSQL.= " AND A.type_id=B.type_id";
$strSQL.= " ORDER BY label";
$result= dbquery($strSQL);
while($row= mysql_fetch_array($result))
{
  $strRuleID = $row['rule_id'];
  $strLabel  = $row['label'];
  $strType   = $row['type'];
  echo "<option value='$strRuleID'>$strLabel [$strType]</option>\n";
}
?>
</select>
</td>
</tr>
<tr>
<td><?=$LA['pi-add-item'];?>:</td>
<td>
[<?=$LA['pi-type'];?>=<select class=forms name="txtAddItemType">
<option value=""><?=$LA['pi-choose'];?></option>
<?
$strSQL = "SELECT * FROM $TABLE_ITEM_TYPE ORDER BY type_id";
$result= dbquery($strSQL);
while($row= mysql_fetch_array($result))
{
  $strType_ID = $row['type_id'];
  $strType    = $row['type'];
  echo "<option value='$strType_ID'>$strType</option>\n";
}
?>
</select>]
 [<?=$LA['pi-label'];?>=<input class=forms name="txtAddItemLabel" type=text value="">]
 [<?=$LA['pi-defv'];?>=<input type=text name="txtDefaultValue">]
</td>
</tr>
    <tr><td colspan=2 align=center>
      <input class=form_button type="submit" value="<?=$LA['pi-perf-action'];?>" name="btnSubmit">
      <input class=form_button type="reset" value="<?=$LA['pi-reset'];?>" name="reset">
    </td></tr>
<tr><td colspan=2 align=center><?=$LA['pi-note-create'];?></td></tr>
</table>
<BR><BR>
<table class=wrap border='0' cellpadding='2'>
<tr>
<td><?=$LA['pi-delete-item'];?>:</td>
<td>
<select class=forms name="txtDeleteItem">
<option value=""><?=$LA['pi-choose'];?></option>
<?
$strSQL = "SELECT * FROM $TABLE_ITEM_TO_PROJECT WHERE project_id='$strProjectID' ORDER BY label";
$result= dbquery($strSQL);
while($row= mysql_fetch_array($result))
{
  $strRuleID = $row['rule_id'];
  $strLabel  = $row['label'];
  echo "<option value='$strRuleID'>$strLabel</option>\n";
}
?>
</select>
      <input class=form_button id=b1 type="button" onclick="this.form.delSub2.tag=1;document.getElementById('b2').className='form_button';document.getElementById('b1').className='form_button2';" value="Step 1 Delete" name="delSub1">
      <input class=form_button2 id=b2 type="button" onclick="if(this.tag){this.form.deleteSubmit.value=1;this.form.submit();}" tag=0 value="<?=$LA['pi-delete-item'];?>" name="delSub2">
      <input type=hidden name="deleteSubmit" value="0">
</td>
</tr>

</table>
</form>
<BR><BR>
<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<input type=hidden name="txtProjectID" value="<?=$strProjectID;?>">
<input type=hidden name="txtDelID" value="">
<input type=hidden name="txtDelF" value="">
<input type=hidden name="txtDelD" value="">
<input type=hidden name="txtDelV" value="">
<table class=wrap border='0' cellpadding='2'>
<tr><td align=center colspan=2><b><?=$LA['pi-item-dep'];?></b></td></tr>
<?
$strSQL2 ="SELECT A.value as value,B.label as first, B.rule_id as first_id, C.label as second, C.rule_id as second_id FROM ($TABLE_ITEM_DEPENDENCY AS A, $TABLE_ITEM_TO_PROJECT AS B , $TABLE_ITEM_TO_PROJECT AS C) WHERE A.rule_id=B.rule_id AND A.drule_id=C.rule_id AND B.project_id='$strProjectID' AND C.project_ID='$strProjectID' ORDER BY A.rule_id";
$result2=dbquery($strSQL2);
$depnum=1;
while($row2=mysql_fetch_array($result2))
{
  $firstValue=$row2['value']?"=\"".$row2['value']."\"":"";
  $firstLabel=$row2['first'];
  $dependLabel=$row2['second'];
  echo "<tr><td><b><i>$dependLabel</i></b> ".$LA['pi-depends-upon']." <b><i>$firstLabel$firstValue</i></b></td><td> Delete #";
  echo "<input class=form_button type=button onclick='this.form.txtDelID.value=$depnum;this.form.txtDelF.value=this.form.del_first_$depnum.value;this.form.txtDelD.value=this.form.del_depend_$depnum.value;this.form.txtDelV.value=this.form.del_value_$depnum.value;this.form.submit();' value='$depnum'>";
  echo "<input type=hidden name='del_first_$depnum' value='".$row2['first_id']."'>";
  echo "<input type=hidden name='del_depend_$depnum' value='".$row2['second_id']."'>";
  echo "<input type=hidden name='del_value_$depnum' value='".$row2['value']."'>";
  echo "</td></tr>";
  $depnum++;
}
?>
<tr><td colspan=2>&nbsp;</td></tr>
<tr>
<td>
<select class=forms name="txtSecondItem">
<option value=""><?=$LA['pi-choose'];?></option>
<?
$strSQL = "SELECT * FROM $TABLE_ITEM_TO_PROJECT WHERE project_id='$strProjectID' ORDER BY label";
$result= dbquery($strSQL);
while($row= mysql_fetch_array($result))
{
  $strRuleID = $row['rule_id'];
  $strLabel  = $row['label'];
  echo "<option value='$strRuleID'>$strLabel</option>\n";
}
?>
</select>
  <?=$LA['pi-depends-upon'];?>
<select class=forms name="txtFirstItem">
<option value=""><?=$LA['pi-choose'];?></option>
<?
$strSQL = "SELECT * FROM $TABLE_ITEM_TO_PROJECT WHERE project_id='$strProjectID' ORDER BY label";
$result= dbquery($strSQL);
while($row= mysql_fetch_array($result))
{
  $strRuleID = $row['rule_id'];
  $strLabel  = $row['label'];
  echo "<option value='$strRuleID'>$strLabel</option>\n";
}
?>
</select>
</td><td><?=$LA['pi-value'];?>=
<input class=forms type=text name="txtDependValue">
<input name="btnAddItem" class=form_button type=submit value="<?=$LA['pi-add-dep'];?>"></td></tr>
</table>
</form>

<?
}
  print "<BR><BR>";
  writeFooter();
?>
